



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>[转]你所不知的 CSS ::before 和 ::after 伪元素用法</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">[转]你所不知的 CSS ::before 和 ::after 伪元素用法</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-01 13:44:21 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>SS 有两个说不上常用的伪类 :before 和 :after，偶尔会被人用来添加些自定义格式什么的，但是它们的功用不仅于此。前几天发现了&nbsp;<a href="http://tympanus.net/Development/CreativeLinkEffects/" rel="external nofollow noreferrer">Creative Link Effects</a>&nbsp;这个非常有意思的介绍创意链接特效的页面，里面惊人的效果大量使用到的特性除了&nbsp;transform 属性进行变形之外，就是接下来要介绍的这两个伪元素了。</p>
<div><img referrerpolicy="no-referrer"src="http://img1.cheny.org/dimblog/2013/10/6c8c93717f50f6fadccb91d09f4b981e1.gif" /></p>
<p>Creative Button Styles</p>
</div>
<h3>一 基本语法</h3>
<p>在了解进阶的应用之前，先来了解一下语法规则。平常仅仅需要将这两个伪元素用于添加一些自定义字符时，只需使用伪类使用的单冒号写法，以保证浏览器的兼容性：</p>
<div>
<ol><li>p:before&nbsp;&nbsp;{}</li></ol>
</div>
<p>不过，在 CSS3 中为了区别伪元素和伪类为伪元素使用了双冒号，因此如果使用了 display 或者 width 等属性时使得显示脱离了原本元素后，建议按照标准双写。过于老的浏览器可能会存在支持问题，不过伪元素大多是配合 CSS3 使用，就无所谓向下兼容了：</p>
<div>
<ol><li>img::after&nbsp;{}</li></ol>
</div>
<p>这两个伪类下特有的属性 content ，用于在 CSS 渲染中向元素逻辑上的头部或尾部添加内容。注意这些添加不会改变文档内容，不会出现在 DOM 中，不可复制，仅仅是在 CSS 渲染层加入。比较有用的是以下几个值：</p>
<ul><li><strong>[String]</strong>&nbsp;- 使用引号包括一段字符串，将会向元素内容中添加字符串。示例：</p>
<div>
<ol><li>a:after&nbsp;{&nbsp;content:&nbsp;"↗";&nbsp;}</li></ol>
</div></li>
<li><strong>attr()</strong>&nbsp;&ndash; 调用当前元素的属性，可以方便的比如将图片的 Alt 提示文字或者链接的 Href 地址显示出来。示例：
<div>
<ol><li>a:after&nbsp;{&nbsp;content:"("&nbsp;attr(href)&nbsp;")";&nbsp;}</li></ol>
</div></li>
<li><strong>url() /&nbsp;<strong>uri()</strong></strong>&nbsp;&ndash; 用于引用媒体文件。示例：
<div>
<ol><li>h1::before&nbsp;{&nbsp;content:&nbsp;url(logo.png);&nbsp;}</li></ol>
</div></li>
<li><strong>counter()</strong>&nbsp;&ndash; &nbsp;调用计数器，可以不使用列表元素实现序号功能。具体请参见&nbsp;counter-increment 和 counter-reset 属性的用法。示例：
<div>
<ol><li>h2:before&nbsp;{&nbsp;counter-increment:&nbsp;chapter;&nbsp;content:&nbsp;"Chapter&nbsp;"&nbsp;counter(chapter)&nbsp;".&nbsp;"&nbsp;}</li></ol>
</div></li></ul>
<h3>二 进阶技巧</h3>
<p>清除浮动是一个时常会遇到的问题，不少人的解决办法是添加一个空的 div 应用 clear:both; 属性。现在，无需增加没有意义的元素，仅需要以下样式即可在元素尾部自动清除浮动：</p>
<div>
<ol><li>.clear-fix&nbsp;{&nbsp;*overflow:&nbsp;hidden;&nbsp;*zoom:&nbsp;1;&nbsp;}</li>
<li>.clear-fix:after&nbsp;{&nbsp;display:&nbsp;table;&nbsp;content:&nbsp;"";&nbsp;width:&nbsp;0;&nbsp;clear:&nbsp;both;&nbsp;}</li></ol>
</div>
<p>许多人喜欢给 blockquote 引用段添加巨大的引号作为背景，这种时候我们就可以用 :before 来代替 background 了，即可以给背景留下空间，还可以直接使用文字而非图片：</p>
<div>
<ol><li>blockquote::before&nbsp;{</li>
<li>content:&nbsp;open-quote;</li>
<li>position:&nbsp;absolute;</li>
<li>z-index:&nbsp;-1;</li>
<li>color:&nbsp;#DDD;</li>
<li>font-size:&nbsp;120px;</li>
<li>font-family:&nbsp;serif;</li>
<li>font-weight:&nbsp;bolder;</li>
<li>}</li></ol>
</div>
<h3>三 特效妙用</h3>
<p>除了简单的添加字符，配合 CSS 强大的定位和特效特性，完全可以达到给简单的元素另外附加最多两个容器的效果。有一点需要注意的是，如果不需要内容仅配合样式属性做出效果，内容属性也不能为空，即 content:&rdquo;" 。否则，其他的样式属性一概不会生效。</p>
<div><img referrerpolicy="no-referrer"src="http://img1.cheny.org/dimblog/2013/10/6cc221614774e78add77d4e7a1171f591.gif" /></p>
<p>悬浮出现方括号</p>
</div>
<p>鼠标移上链接，出现方括号：</p>
<div>
<ol><li>a&nbsp;{</li>
<li>position:&nbsp;relative;</li>
<li>display:&nbsp;inline-block;</li>
<li>outline:&nbsp;none;</li>
<li>text-decoration:&nbsp;none;</li>
<li>color:&nbsp;#000;</li>
<li>font-size:&nbsp;32px;</li>
<li>padding:&nbsp;5px&nbsp;10px;</li>
<li>}</li>
<li>a:hover::before,&nbsp;a:hover::after&nbsp;{&nbsp;position:&nbsp;absolute;&nbsp;}</li>
<li>a:hover::before&nbsp;{&nbsp;content:&nbsp;"\5B";&nbsp;left:&nbsp;-20px;&nbsp;}</li>
<li>a:hover::after&nbsp;{&nbsp;content:&nbsp;"\5D";&nbsp;right:&nbsp;&nbsp;-20px;&nbsp;}</li></ol>
</div>
<p>同样，我们只需要配合 display: block 和 position: absolute ，就可以将其当成两个容器，拼合成悬浮出现双边框的特效：</p>
<div>
<ol><li>a&nbsp;{</li>
<li>position:&nbsp;relative;</li>
<li>display:&nbsp;inline-block;</li>
<li>outline:&nbsp;none;</li>
<li>text-decoration:&nbsp;none;</li>
<li>color:&nbsp;#000;</li>
<li>font-size:&nbsp;32px;</li>
<li>padding:&nbsp;0&nbsp;10px;</li>
<li>}</li>
<li>/*&nbsp;大框&nbsp;*/</li>
<li>a:hover::before,&nbsp;a:hover::after&nbsp;{</li>
<li>content:&nbsp;"";</li>
<li>display:&nbsp;block;</li>
<li>position:&nbsp;absolute;</li>
<li>top:&nbsp;-15%%;</li>
<li>left:&nbsp;-14%%;</li>
<li>width:&nbsp;120%;</li>
<li>height:&nbsp;120%;</li>
<li>border-style:&nbsp;solid;</li>
<li>border-width:&nbsp;4px;</li>
<li>border-color:&nbsp;#DDD;</li>
<li>}</li>
<li>/*&nbsp;小框&nbsp;*/</li>
<li>a:hover::after&nbsp;{</li>
<li>top:&nbsp;0%;</li>
<li>left:&nbsp;0%;</li>
<li>width:&nbsp;100%;</li>
<li>height:&nbsp;100%;</li>
<li>border-width:&nbsp;2px;</li>
<li>}</li></ol>
</div>
<p>用 :before 和 :after 伪类结合更多 CSS3 强大的特性，还可以完成非常多有意思的特效和 Hack ，这里权当抛砖引玉，诸位又能想出什么妙用呢？</p>
<p>原文：<a href="http://blog.dimpurr.com/css-before-after/" rel="external nofollow noreferrer">http://blog.dimpurr.com/css-before-after/</a></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/jqd5d79d.html">ASP&period;Net MVC&mdash;&mdash;使用 ITextSharp 完美解决HTML转PDF（中文也可以）</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8e004xq.html">PHP慢脚本日志和Mysql的慢查询日志</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvdovyq.html">js生成带参的二维码</a>
		</li>
						<li><a href="https://www.batexi.com/a/r932yzrq.html">Android 控件知识点</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qw3y3k9.html">virtualbox 安装 虚拟机的时候报错不能创建新任务</a>
		</li>
						<li><a href="https://www.batexi.com/a/4954oozq.html">win7下面完全删除mysql</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xrrn68.html">C&plus;&plus;Primer 第十七章</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vvdl38.html">iOS进阶收藏</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7m1omkq.html">mapreduce引用第三方jar</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zgx069.html">js柯里化的一个应用</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jz02oe8.html">邮件应用Acompli和日历应用Sunrise（传微软曾考虑以80亿美元收购企业通讯公司Slack）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjzzey8.html">单源最短路径（1）：Dijkstra 算法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kped059.html">关于页面传参，decodeURI和decodeURIComponent</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pr1rj8.html">【Oracle学习笔记】序列</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnv1rl28.html">&lbrack;STM32F103&rsqb;定时器PWM输入</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvolpx8.html">Unity 3D光源-Directional平行光&sol;逆光效果，光晕详解、教程</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjwkjz9.html">2017java文本文件操作（读写操作）</a>
		</li>
						<li><a href="https://www.batexi.com/a/953xoj68.html">【noip模拟赛3】确定的位置  （map的遍历  位置原理）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9530rom8.html">BZOJ 4610&colon; &lbrack;Wf2016&rsqb;Ceiling Functi 水题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyv71wjq.html">Visual Studio Code Angular4 配置环境</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8kojll3q.html">java 和 C&plus;&plus; Socket通信（java作为服务端server，C&plus;&plus;作为客户端client，解决中文乱码问题GBK和UTF8）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8em47kx9.html">CListCtrl自适应宽度</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o41p4xq.html">FreeSWITCH增加iLBC编码</a>
			</li>
						<li><a href="https://www.batexi.com/a/902rx7nq.html">Android新特性--ConstraintLayout完全解析</a>
			</li>
						<li><a href="https://www.batexi.com/a/9ppwokk9.html">springboot 整合 Redis 方法二</a>
			</li>
						<li><a href="https://www.batexi.com/a/qx2dm7j8.html">CentOS 安装Mosquitto及测试</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwlvgpk9.html">java、oracle对CLOB处理</a>
			</li>
						<li><a href="https://www.batexi.com/a/93pw44w8.html">IOS团队开发之&mdash;&mdash;CocoaPods 第三方库管理工具</a>
			</li>
						<li><a href="https://www.batexi.com/a/93pwz3z8.html">Pipeline 与 xargs</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2k547wq.html">&lbrack;fixed&rsqb; 解决 slf4j &plus; log4j  eclipse 可以打印日志，而在云服务器上不能打印</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
